Index: trunk/SophyaLib/Samba/spheregorski.cc
===================================================================
--- trunk/SophyaLib/Samba/spheregorski.cc	(revision 473)
+++ trunk/SophyaLib/Samba/spheregorski.cc	(revision 487)
@@ -11,9 +11,4 @@
 }
       
-extern "C" 
-{
-void anafast_(int&,int&,int&,double&,float*,float*,float*,float*,float*,float*,float*);
-void synfast_(int&,int&,int&,int&,float&,float*,float*,float*,double*,double*,double*,double*,double*,float*);
-}
 
 //*******************************************************************
@@ -25,5 +20,4 @@
 PIXELS_XY::PIXELS_XY()
 {
-  cout << " appel du constructeur PIXELS_XY " <<endl;
   pix2x_.ReSize(1024);
   pix2x_.Reset();
@@ -189,5 +183,4 @@
 //--
 {
-  cout<<" appel du constructeur SphereGorski ()" <<endl;
   InitNul();
 }
@@ -202,5 +195,4 @@
 //--
 {
-  cout<<" appel du constructeur SphereGorski (m)" <<endl;
 
   if(m <= 0 || m > 8192) 
@@ -233,11 +225,4 @@
   pixels_= s.pixels_;
 
-  nlmax_= s.nlmax_;
-  nmmax_= s.nmmax_;
-  iseed_= s.iseed_;
-  fwhm_ = s.fwhm_;
-  quadrupole_ = s.quadrupole_;
-  sym_cut_deg_= s.sym_cut_deg_;
-  strcpy(powFile_,s.powFile_);
 }
 
@@ -322,11 +307,4 @@
   pixels_.Reset();
 
-  nlmax_= 0;
-  nmmax_= 0;
-  iseed_= 0;
-  fwhm_ = 0.;
-  quadrupole_ = 0.;
-  sym_cut_deg_= 0.;
-  for(int k = 0; k < 128; k++) powFile_[k]=' ';
 }
 
@@ -550,130 +528,4 @@
 }
 
-/*
-//++
-template<class T> 
-void SphereGorski<T>::anharm(int nlmax, float sym_c,float* powspec) 
-//
-//    analyse en harmoniques spheriques des valeurs des pixels de la 
-//    sphere : appel du module anafast (Gorski-Hivon)
-//
-//    "nlmax"   : multipole maximum, nlmax <= 2*nsmax (cf. Nyquist)
-//
-//    "sym c"   : coupure symetrique autour de l'equateur (degres)
-//
-//    "powspec" : tableau resultat (a reserver avant l'appel) de C(l) 
-//    (spectre de puissance)
-//
-//--
-//
-// Pb a resoudre : dans cette classe les valeurs de pixel sont "double"
-// dans anafast le tableau correspondant est "float"
-// pour l'instant on duplique les tableaux, il faudra decider quelque chose
-//
-{ 
-    if (nlmax > 2*nSide_) {
-          cout << " anharm : nlmax= " << nlmax << 
-                          " doit etre <= 2*nsmax (cf. Nyquist), soit :" << 2*nSide_ << endl;
-         exit(1);
-  }
-  else {
-    nlmax_=nlmax;
-    nmmax_=nlmax_;
-  }
-  sym_cut_deg_=sym_c;
-  float* map=new float[nPix_];
-  for (int k=0; k<nPix_; k++) map[k]=(float)pixels_(k);
-  int nsmax=nSide_;
-  int nmmax=nmmax_;
-  double sc=(double)sym_cut_deg_;
-  float* alm_T=new float[2*(nlmax+1)*(nmmax+1)];
-  if (powspec==NULL) {
-    
-    cout << 
-      " anharm : un tableau de C_l doit etre alloue avant appel " << endl;
-    exit(1);
-  }
-  float* phas_n=new float[2*(nmmax+1)];
-  float* phas_s=new float[2*(nmmax+1)];
-  float*  dataw =new float[16*nsmax];
-  float*  work =new float[16*nsmax];
-
-  anafast_(nsmax,nlmax,nmmax,sc,map,alm_T, powspec,phas_n,phas_s,dataw,work);
-  quadrupole_=powspec[2];
-  delete [] map;
-  delete [] alm_T;
-  delete [] phas_n;
-  delete [] phas_s;
-  delete [] dataw;
-  delete [] work;  
-}
-*/
-
-/*
-//++
-template<class T>
-void SphereGorski<T>::synharm(int nlmax, int iseed,float fwhm, float* powspec) 
-//
-//    synthese  des valeurs des pixels de la sphere par l'intermediaire 
-//    des coefficients en harmoniques spheriques reconstitues apartir d'un 
-//    spectre en puissance : appel du module synfast (Gorski-Hivon)
-//
-//    powspec est un tableau (a fournir) de C(l) (spectre de puissance)
-//    Ce tableau doit contenir les valeur de C(l) par ordre 
-//    SEQUENTIEL de l (de l=0 a l=nlmax). IL SERA MODIFIE PAR L'ALGORITHME
-//
-//    nlmax : multipole maximum (nlmax <= 2*nsmax (cf. Nyquist)
-//    iseed : initialisation generation aleatoire (negatif, suggere : -1)
-//    fwhm  : largeur totale a mi-hauteur (minutes d'arc, >=0, ex: 5)
-//--
-// Pb a resoudre : dans cette classe les valeurs de pixel sont "double"
-// dans anafast le tableau correspondant est "float"
-// pour l'instant on duplique les tableaux, il faudra decider quelque chose
-
-{
-  if (nlmax > 2*nSide_) {
-    cout << " sphereGorski::synharm: nlmax= " << nlmax << 
-            " doit etre <= 2*nsmax (cf. Nyquist), soit : " << 2*nSide_ << endl;
-    exit(1);
-  }
-  else {
-    nlmax_=nlmax;
-    nmmax_=nlmax_;
-    quadrupole_=powspec[2];
-  }
-  if (powspec==NULL) {
-    
-    cout << 
-      "sphereGorski::synharm : un tableau de C_l doit etre alloue avant appel"
-	 << endl;
-    exit(1);
-  }
-  iseed_=iseed;
-  fwhm_ =fwhm; 
-  float* map=new float[nPix_];
-  int nsmax=nSide_;
-  int nmmax=nmmax_;
-  float* alm_T=new float[2*(nlmax+1)*(nmmax+1)]; 
-
-  //    tableaux de travail 
-  double* b_north=new double[2*(2*nmmax+1)];
-  double* b_south=new double[2*(2*nmmax+1)];
-  double* bw=new double[2*4*nsmax];
-  double* data=new double[2*4*nsmax];
-  double* work=new double[2*4*nsmax];
-  float* lread=new float[nlmax+1];
-  synfast_(nsmax,nlmax,nmmax,iseed,fwhm, map,alm_T, powspec,
-                  b_north,b_south,bw,data,work,lread);
-  for (int k=0; k<nPix_; k++) pixels_(k) = (T)map[k];
-  delete [] map;
-  delete [] alm_T;
-  delete [] b_north;
-  delete [] b_south;
-  delete [] bw; 
-  delete [] data;
-  delete [] work;
-  delete [] lread;
-}
-*/
 
 template<class T>
@@ -1195,49 +1047,5 @@
 }
 
-// retourne le nom du fichier qui contient le spectre de puissance
-template<class T>
-void SphereGorski<T>::powfile(char filename[]) const 
-{
-  bool status = false;
-  for (int k=0; k< 128; k++)
-    {
-      if( powFile_[k] != ' ' )
-	{
-	  status = true;
-	  break;
-	}
-    }
-  if ( status ) 
-    {
-      strcpy(filename,powFile_);
-    }
-  else
-    {
-      strcpy(filename,"no file");
-    }
-}
-
-template<class T>
-void SphereGorski<T>::getParafast(int& nlmax,int& nmmax,int& iseed,float& fwhm,float& quadr,float& cut) const
-{
-  nlmax= nlmax_;
-  nmmax= nmmax_;
-  iseed= iseed_;
-  fwhm = fwhm_;
-  quadr= quadrupole_;
-  cut  = sym_cut_deg_;
-}
-
-template<class T>
-void SphereGorski<T>::setParafast(int nlmax,int nmmax,int iseed,float fwhm,float quadr,float cut,char* filename)
-{
-  nlmax_= nlmax;
-  nmmax_= nmmax;
-  iseed_= iseed;
-  fwhm_ = fwhm;
-  quadrupole_ = quadr;
-  sym_cut_deg_= cut; 
-  strcpy(powFile_,filename);
-}
+
 
 template <class T>
@@ -1250,5 +1058,5 @@
   os << " omeg_ = " << omeg_   << endl;
 
-  os << " contenu de pixels : ";
+  os << " content of pixels : ";
   for(int i=0; i < nPix_; i++)
     {
@@ -1259,17 +1067,13 @@
 
   os << endl;
-  const PIXELS_XY& PXY= PIXELS_XY::instance();
-
-  os << endl;  os << " contenu des tableaux conversions "<<endl;
-  for(int i=0; i < 5; i++)
-    {
-      os<<PXY.pix2x_(i)<<", "<<PXY.pix2y_(i)<<", "<<PXY.x2pix_(i)<<", "<<PXY.y2pix_(i)<<endl;
-    }
+  //const PIXELS_XY& PXY= PIXELS_XY::instance();
+
+  //os << endl;  os << " contenu des tableaux conversions "<<endl;
+  //for(int i=0; i < 5; i++)
+  //  {
+  //   os<<PXY.pix2x_(i)<<", "<<PXY.pix2y_(i)<<", "<<PXY.x2pix_(i)<<", "<<PXY.y2pix_(i)<<endl;
+  // }
   os << endl;
 
-  os << " les parametres des modules anafast et synfast " <<endl;
-  os << " nlmax, nmmax & iseed= " <<nlmax_<<", "<<nmmax_<<", "<<iseed_<<endl;
-  os << " fwhm, quadr & cut = "<<fwhm_<<", "<<quadrupole_<<", "<<sym_cut_deg_<<endl;
-  os << " powfile= " << powFile_<<endl;
 }
 
@@ -1357,18 +1161,4 @@
   delete [] pixels;
 
-  int nlmax,nmmax,iseed;
-  is.GetI4(nlmax);
-  is.GetI4(nmmax);
-  is.GetI4(iseed);
-  
-  float fwhm,quadr,cut;
-  is.GetR4(fwhm);
-  is.GetR4(quadr);
-  is.GetR4(cut);
-
-  char powfl[128];
-  is.GetLine(powfl, 127);
-
-  dobj->setParafast(nlmax,nmmax,iseed,fwhm,quadr,cut,powfl);
 }
 
@@ -1406,17 +1196,5 @@
   PIOSWriteArray(os,(dobj->getDataBlock())->Data(), nPix);
 
-  int nlmax,nmmax,iseed;
-  float fwhm,quadr,cut;
-  dobj->getParafast(nlmax,nmmax,iseed,fwhm,quadr,cut);
-  os.PutI4(nlmax);
-  os.PutI4(nmmax);
-  os.PutI4(iseed);
-  os.PutR4(fwhm);
-  os.PutR4(quadr);
-  os.PutR4(cut);
-
-  char powfl[128];
-  dobj->powfile(powfl);
-  os.PutLine(powfl);
+
 }
 