Index: trunk/SophyaPI/PIext/nobjmgr.cc
===================================================================
--- trunk/SophyaPI/PIext/nobjmgr.cc	(revision 486)
+++ trunk/SophyaPI/PIext/nobjmgr.cc	(revision 493)
@@ -778,5 +778,9 @@
 {
 bool ok = true;
+#ifdef SANS_EVOLPLANCK 
 RzImage* obj;
+#else
+//CMV_A_FAIRE RzImage* obj;
+#endif
 
 TRY{
Index: trunk/SophyaPI/PIext/piafitting.cc
===================================================================
--- trunk/SophyaPI/PIext/piafitting.cc	(revision 486)
+++ trunk/SophyaPI/PIext/piafitting.cc	(revision 493)
@@ -498,8 +498,15 @@
      return;}
   }
+#ifdef SANS_EVOLPLANCK
 else if (dynamic_cast<RzImage*>(mObj)) {
   mNVar = 2;
   mIm = (RzImage*) mObj; mNBinX = mIm->XSize(); mNBinY = mIm->YSize();
   }
+#else
+//CMV_A_FAIRE else if (dynamic_cast<RzImage*>(mObj)) {
+//CMV_A_FAIRE   mNVar = 2;
+//CMV_A_FAIRE   mIm = (RzImage*) mObj; mNBinX = mIm->XSize(); mNBinY = mIm->YSize();
+//CMV_A_FAIRE   }
+#endif
 else {
   cout<<"PIAFitter::DecodeObject Error , Objet n'est pas un "
@@ -878,4 +885,7 @@
   string nomres = mNObj + "_res";
   string nomfun = mNObj + "_fun";
+//####################
+#ifdef SANS_EVOLPLANCK
+//####################
   if(mV) {
     if(mOpt.okres) {Vector* ob = mV->FitResidus(*mFit);  if(ob) omg.AddObj(ob,nomres);}
@@ -907,4 +917,39 @@
       {GeneralFitData* ob = mG->FitFunction(*mFit); if(ob) omg.AddObj(ob,nomfun);}
   }
+//####################
+#else
+//####################
+  if(mV) {
+    if(mOpt.okres) {Vector* ob = new Vector(mV->FitResidus(*mFit));  if(ob) omg.AddObj(ob,nomres);}
+    if(mOpt.okfun) {Vector* ob = new Vector(mV->FitFunction(*mFit)); if(ob) omg.AddObj(ob,nomfun);}
+  } else if(mH) {
+    if(mOpt.okres) {Histo* ob =  new Histo(mH->FitResidus(*mFit));  if(ob) omg.AddObj(ob,nomres);}
+    if(mOpt.okfun) {Histo* ob =  new Histo(mH->FitFunction(*mFit)); if(ob) omg.AddObj(ob,nomfun);}
+  } else if(mM) {
+    if(mOpt.okres) {Matrix* ob = new Matrix(mM->FitResidus(*mFit));  if(ob) omg.AddObj(ob,nomres);}
+    if(mOpt.okfun) {Matrix* ob = new Matrix(mM->FitFunction(*mFit)); if(ob) omg.AddObj(ob,nomfun);}
+  } else if(mH2) {
+    if(mOpt.okres)
+      {Histo2D* ob = new Histo2D(mH2->FitResidus(*mFit));  if(ob) omg.AddObj(ob,nomres);}
+    if(mOpt.okfun)
+      {Histo2D* ob = new Histo2D(mH2->FitFunction(*mFit)); if(ob) omg.AddObj(ob,nomfun);}
+//CMV_A_FAIRE  } else if(mIm) {
+//CMV_A_FAIRE    if(mOpt.okres) {
+//CMV_A_FAIRE      RzImage* ob = mIm->FitResidus(*mFit);  
+//CMV_A_FAIRE      if(ob) {ImageR4* rob = new ImageR4(*ob); omg.AddObj(rob,nomres); delete ob;}
+//CMV _A_FAIRE    }
+//CMV_A_FAIRE    if(mOpt.okfun) {
+//CMV_A_FAIRE      RzImage* ob = mIm->FitFunction(*mFit);
+//CMV_A_FAIRE      if(ob) {ImageR4* rob = new ImageR4(*ob); omg.AddObj(rob,nomfun); delete ob;}
+//CMV_A_FAIRE    }
+  } else if(mG) {
+    if(mOpt.okres)
+      {GeneralFitData* ob = new GeneralFitData(mG->FitResidus(*mFit));  if(ob) omg.AddObj(ob,nomres);}
+    if(mOpt.okfun)
+      {GeneralFitData* ob = new GeneralFitData(mG->FitFunction(*mFit)); if(ob) omg.AddObj(ob,nomfun);}
+  }
+//####################
+#endif
+//####################
 }
 return;
Index: trunk/SophyaPI/PIext/piafitting.h
===================================================================
--- trunk/SophyaPI/PIext/piafitting.h	(revision 486)
+++ trunk/SophyaPI/PIext/piafitting.h	(revision 493)
@@ -22,5 +22,10 @@
 class GeneralFunction; class GeneralFunc; class GeneralFit;
 class GeneralFitData;
-class Histo; class Matrix; class Histo2D; class RzImage;
+class Histo; class Matrix; class Histo2D;
+#ifdef SANS_EVOLPLANCK
+class RzImage;
+#else
+//CMV_A_FAIRE class RzImage;
+#endif
 
 class PIAFitter : public CmdExecutor {
@@ -88,5 +93,10 @@
 // Possibles objets a fitter
 Vector* mV; Histo* mH; // Do not delete
-Matrix* mM; Histo2D* mH2; RzImage* mIm; // Do not delete
+Matrix* mM; Histo2D* mH2; // Do not delete
+#ifdef SANS_EVOLPLANCK
+RzImage* mIm; // Do not delete
+#else
+//CMV_A_FAIRE RzImage* mIm; // Do not delete
+#endif
 GeneralFitData* mG; // Do not delete
 // Gestion des fonctions de fit predefinies
Index: trunk/SophyaPI/PIext/pimgadapter.h
===================================================================
--- trunk/SophyaPI/PIext/pimgadapter.h	(revision 486)
+++ trunk/SophyaPI/PIext/pimgadapter.h	(revision 493)
@@ -5,4 +5,5 @@
 #include "parradapter.h"
 
+#ifdef SANS_EVOLPLANCK 
 class RzImageAdapter : public P2DArrayAdapter {
 public:
@@ -19,4 +20,5 @@
   RzImage* mImg;
 };
+#endif
 
 template <class T> 